"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableHeadings = exports.DataTableHeading = exports.DataTableHeadingMenu = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const components_datatable_extras_1 = require("@react_db_client/components.datatable.extras");
const components_emoji_1 = require("@react_db_client/components.emoji");
const components_datatable_logic_1 = require("@react_db_client/components.datatable.logic");
const constants_client_types_1 = require("@react_db_client/constants.client-types");
const hooks_use_auto_hide_panel_hook_1 = require("@react_db_client/hooks.use-auto-hide-panel-hook");
const components_datatable_cell_1 = require("@react_db_client/components.datatable.cell");
const DataTableHeadingMenu = ({ handleAddFilter, setSortBy, headingData, handleHideColumn, }) => {
    const { allowFilters, allowSortBy, allowHiddenColumns } = (0, react_1.useContext)(components_datatable_logic_1.DataTableContext);
    const className = 'dataTableHeading_menuBtnWrap';
    const menuRef = (0, react_1.useRef)(null);
    const [menuOpen, setMenuOpen] = (0, hooks_use_auto_hide_panel_hook_1.useAutoHidePanel)(menuRef, true, false);
    const allowMenu = allowFilters || allowSortBy || allowHiddenColumns;
    return (react_1.default.createElement("div", { className: "dataTableHeading_menuWrap" },
        allowMenu && (react_1.default.createElement("button", { className: "dataTableCell_btn filterBtn", type: "button", onClick: () => setMenuOpen(!menuOpen) },
            react_1.default.createElement(components_emoji_1.Emoji, { emoj: "\uD83D\uDD3D", label: "DropDownMenu" }))),
        menuOpen && (react_1.default.createElement("div", { className: className, ref: menuRef },
            allowFilters && (react_1.default.createElement("button", { className: "dataTableCell_btn filterBtn", type: "button", onClick: () => {
                    handleAddFilter(new constants_client_types_1.FilterObjectClass({
                        field: headingData.uid,
                        type: headingData.type,
                        label: headingData.label,
                    }));
                    setMenuOpen(false);
                } }, "Filter by")),
            allowSortBy && (react_1.default.createElement("button", { className: "dataTableCell_btn sortBtn", type: "button", onClick: () => {
                    setSortBy(headingData.uid);
                    setMenuOpen(false);
                } }, "Sort By")),
            allowHiddenColumns && (react_1.default.createElement("button", { className: "dataTableCell_btn hideBtn", type: "button", onClick: () => {
                    handleHideColumn(headingData.uid);
                    setMenuOpen(false);
                } }, "Hide Column"))))));
};
exports.DataTableHeadingMenu = DataTableHeadingMenu;
exports.DataTableHeadingMenu.propTypes = {
    handleAddFilter: prop_types_1.default.func.isRequired,
    setSortBy: prop_types_1.default.func.isRequired,
    handleHideColumn: prop_types_1.default.func.isRequired,
    headingData: prop_types_1.default.shape({
        uid: prop_types_1.default.string.isRequired,
        label: prop_types_1.default.string.isRequired,
        type: prop_types_1.default.string.isRequired,
    }).isRequired,
};
const DataTableHeading = ({ title }) => (react_1.default.createElement("div", { className: "dataTableHeading" },
    react_1.default.createElement("div", { className: "heading" }, title)));
exports.DataTableHeading = DataTableHeading;
exports.DataTableHeading.propTypes = {
    title: prop_types_1.default.string.isRequired,
};
const DataTableHeadings = ({ headingsDataList, setSortBy, handleHideColumn, columnWidths, handleAddFilter, showFilterBtns, tableWidth, }) => {
    const [activeColumn, setActiveColumn] = (0, react_1.useState)(null);
    const { hasBtnsColumn } = (0, react_1.useContext)(components_datatable_logic_1.DataTableContext);
    const outsideWrapClassName = ['dataTable_headingsOutsideWrap'].join(' ');
    const insideWrapClassName = ['dataTable_headingsInsideWrap'].join(' ');
    const insideWrapStyleOverride = {
        width: `${tableWidth}px`,
        // position: 'relative',
    };
    const addFilter = (newFilter) => {
        handleAddFilter(newFilter);
    };
    const handleChangeSortBy = (newSortBy) => {
        setSortBy(newSortBy);
    };
    // Map Headings to UI
    const className = 'dataTableHeading_cellWrap';
    const mapHeadings = headingsDataList.map((headingData, i) => (react_1.default.createElement(components_datatable_cell_1.DataTableCellHoverWrap, { className: className, key: headingData.uid, columnWidth: columnWidths[hasBtnsColumn ? i + 1 : i], handleHover: () => setActiveColumn(i) },
        react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(exports.DataTableHeading, { key: headingData.uid, title: headingData.label }),
            showFilterBtns && i === activeColumn && (react_1.default.createElement(exports.DataTableHeadingMenu, { handleAddFilter: addFilter, setSortBy: handleChangeSortBy, handleHideColumn: handleHideColumn, headingData: headingData }))))));
    // if we can edit rows then we need to add extra column for edit buttons
    if (hasBtnsColumn) {
        mapHeadings.unshift(react_1.default.createElement(components_datatable_cell_1.DataTableCellHoverWrap, { className: className, key: "Settings", columnWidth: columnWidths[0] },
            react_1.default.createElement(react_1.default.Fragment, null)));
    }
    return (react_1.default.createElement("div", { className: outsideWrapClassName },
        react_1.default.createElement("div", { className: insideWrapClassName, style: insideWrapStyleOverride }, mapHeadings)));
};
exports.DataTableHeadings = DataTableHeadings;
exports.DataTableHeadings.propTypes = {
    headingsDataList: prop_types_1.default.arrayOf(prop_types_1.default.shape(components_datatable_extras_1.headingDataShape)).isRequired,
    setSortBy: prop_types_1.default.func.isRequired,
    handleHideColumn: prop_types_1.default.func.isRequired,
    handleAddFilter: prop_types_1.default.func.isRequired,
    columnWidths: prop_types_1.default.arrayOf(prop_types_1.default.number).isRequired,
    showFilterBtns: prop_types_1.default.bool,
    tableWidth: prop_types_1.default.number.isRequired,
};
exports.DataTableHeadings.defaultProps = {
    showFilterBtns: true,
};
exports.default = exports.DataTableHeadings;
//# sourceMappingURL=DataTableHeadings.js.map