"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTableTotals = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const components_datatable_extras_1 = require("@react_db_client/components.datatable.extras");
const components_datatable_logic_1 = require("@react_db_client/components.datatable.logic");
const helpers_data_processing_1 = require("@react_db_client/helpers.data-processing");
const components_datatable_cell_types_1 = require("@react_db_client/components.datatable.cell-types");
const DataTableTotals = ({ className, headingsDataList, columnWidths, totals, tableWidth, componentMap, }) => {
    const { hasBtnsColumn } = (0, react_1.useContext)(components_datatable_logic_1.DataTableContext);
    const insideWrapStyleOverride = {
        width: `${tableWidth}px`,
    };
    const mapTotals = headingsDataList.map((headingData, i) => {
        const cellData = headingData.showTotals ? ((0, helpers_data_processing_1.formatValue)(Number(totals[headingData.uid]), headingData.step || 0.01)) : (react_1.default.createElement("div", null));
        return (react_1.default.createElement(components_datatable_cell_types_1.DataTableCellHoverWrap, { key: headingData.uid, columnWidth: columnWidths[hasBtnsColumn ? i + 1 : i], className: "dataTableTotals" }, headingData.showTotals ? (react_1.default.createElement(components_datatable_cell_types_1.DataTableDataCell, { rowId: "_totals", rowIndex: -1, rowData: {}, classNames: className, columnId: headingData.uid, cellData: cellData, columnData: headingData, 
            // cellDataBtnRef={cellDataBtnRef}
            componentMap: componentMap, updateData: () => { }, acceptValue: () => { }, resetValue: () => { }, focused: false, editMode: false, isDisabled: false })) : (react_1.default.createElement("div", null))));
    });
    if (hasBtnsColumn) {
        mapTotals.unshift(react_1.default.createElement(components_datatable_cell_types_1.DataTableCellHoverWrap, { className: "dataTableTotals", key: "Settings", columnWidth: columnWidths[0] },
            react_1.default.createElement(react_1.default.Fragment, null)));
    }
    return (react_1.default.createElement("div", { className: "dataTable_totalsOutsideWrap" },
        react_1.default.createElement("div", { className: "dataTable_totalsInsideWrap", style: insideWrapStyleOverride }, mapTotals)));
};
exports.DataTableTotals = DataTableTotals;
exports.DataTableTotals.propTypes = {
    headingsDataList: prop_types_1.default.arrayOf(prop_types_1.default.shape(components_datatable_extras_1.headingDataShape)).isRequired,
    totals: prop_types_1.default.objectOf(prop_types_1.default.number).isRequired,
    columnWidths: prop_types_1.default.arrayOf(prop_types_1.default.number).isRequired,
    tableWidth: prop_types_1.default.number.isRequired,
    componentMap: prop_types_1.default.objectOf(prop_types_1.default.elementType).isRequired,
    className: prop_types_1.default.string,
};
exports.DataTableTotals.defaultProps = {
    className: '',
};
exports.default = exports.DataTableTotals;
//# sourceMappingURL=DataTableTotals.js.map