"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const enzyme_1 = require("enzyme");
const components_datatable_extras_1 = require("@react_db_client/components.datatable.extras");
const DataTableTotals_1 = require("./DataTableTotals");
const components_datatable_cell_1 = require("@react_db_client/components.datatable.cell");
const defaultProps = {
    headingsDataList: components_datatable_extras_1.demoHeadingsData,
    columnWidths: components_datatable_extras_1.demoHeadingsData.map(() => 10),
    totals: components_datatable_extras_1.demoHeadingsData.map(() => 10),
    tableWidth: components_datatable_extras_1.demoHeadingsData.reduce((acc, v) => acc + v),
    customFieldComponents: {},
};
describe('DataTableTotals', () => {
    beforeEach(() => { });
    test('Renders', () => {
        (0, enzyme_1.shallow)(react_1.default.createElement(DataTableTotals_1.DataTableTotals, Object.assign({}, defaultProps)));
    });
    describe('shallow renders', () => {
        test('Matches Snapshot', () => {
            const component = (0, enzyme_1.shallow)(react_1.default.createElement(DataTableTotals_1.DataTableTotals, Object.assign({}, defaultProps)));
            const tree = component.debug();
            expect(tree).toMatchSnapshot();
        });
    });
    describe('Unit tests', () => {
        let component;
        beforeEach(() => {
            component = (0, enzyme_1.mount)(react_1.default.createElement(DataTableTotals_1.DataTableTotals, Object.assign({}, defaultProps)));
        });
        describe('Showing Totals', () => {
            test('should show totals for columns with showTotals set to true', () => {
                const totalsRow = component.find(components_datatable_cell_1.DataTableCellHoverWrap);
                const totalsCells = totalsRow.find(components_datatable_cell_1.DataTableDataCell);
                expect(totalsCells).toHaveLength(components_datatable_extras_1.demoHeadingsData.filter((h) => h.showTotals).length); // Not sure why there are double here
                expect(totalsCells.debug()).toMatchSnapshot();
            });
        });
    });
});
//# sourceMappingURL=DataTableTotals.test.js.map